=== debian/changelog ===
netsurf (3.8-0.1~mx17+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 08 Nov 2018 14:22:03 -0800

netsurf (3.7-0.1~mx17+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 25 Apr 2018 13:51:58 -0700
